 /* Copyright (c) 2006 Itzhak Fadida.  All Rights Reserved. */
#include "postgres.h"
#include "utils/palloc.h"
#include "algstructs.h"
#include "algutils.h"
PG_FUNCTION_INFO_V1(getfdr);


Datum
getfdr(PG_FUNCTION_ARGS)
{

		FuncCallContext *funcctx = NULL;


		alg_fctx * fctx = (alg_fctx *) palloc(sizeof(alg_fctx));

		initialize_general_structures(fcinfo, fctx, funcctx);

		int			l = 0;


		int			sizeOfHeader = (20 + MaxHeapAttributeNumber * 50) * sizeof(char);


		text	   *resultTupleRecord = (text *) palloc(sizeOfHeader + VARHDRSZ);


		char	   *header;


		char	   *toh;

		SET_VARSIZE(resultTupleRecord, sizeOfHeader + VARHDRSZ);
		header = toh = VARDATA(resultTupleRecord);

		toh = (char *) stpcpy(toh, "(");

		for (l = 0; l < fctx->resultTupleNAtt; l++)
	{

			toh = (char *) stpcpy(toh, fctx->resultTupleAttNames[l]);

			toh = (char *) stpcpy(toh, " ");

			toh = (char *) stpcpy(toh, SPI_gettype(fctx->resultTupleDesc, l + 1));

			if (l != (fctx->resultTupleNAtt - 1))

				toh = (char *) stpcpy(toh, ",");

	}
		toh = (char *) stpcpy(toh, ")");

		SET_VARSIZE(resultTupleRecord, strlen(header) + VARHDRSZ);

		PG_RETURN_TEXT_P(resultTupleRecord);

}
